DescriptorProtos.MethodOptions.IdempotencyLevel
Date: 2017-07-08

com.google.protobuf

## Enum DescriptorProtos.MethodOptions.IdempotencyLevel

- java.lang.Object
- - java.lang.Enum<DescriptorProtos.MethodOptions.IdempotencyLevel>
  - - com.google.protobuf.DescriptorProtos.MethodOptions.IdempotencyLevel

- All Implemented Interfaces:
    Internal.EnumLite, ProtocolMessageEnum, java.io.Serializable, java.lang.Comparable<DescriptorProtos.MethodOptions.IdempotencyLevel>
  Enclosing class:
    DescriptorProtos.MethodOptions

      public static enum DescriptorProtos.MethodOptions.IdempotencyLevel
      extends java.lang.Enum<DescriptorProtos.MethodOptions.IdempotencyLevel>
      implements ProtocolMessageEnum

       Is this method side-effect-free (or safe in HTTP parlance), or idempotent,
       or neither? HTTP based RPC implementation may choose GET verb for safe
       methods, and PUT verb for idempotent methods instead of the default POST.

  Protobuf enum `google.protobuf.MethodOptions.IdempotencyLevel`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `IDEMPOTENCY_UNKNOWN` `IDEMPOTENCY_UNKNOWN = 0;`
    `IDEMPOTENT` idempotent, but may have side effects
    `NO_SIDE_EFFECTS` implies idempotent

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `IDEMPOTENCY_UNKNOWN_VALUE` `IDEMPOTENCY_UNKNOWN = 0;`
    `static int` | `IDEMPOTENT_VALUE` idempotent, but may have side effects
    `static int` | `NO_SIDE_EFFECTS_VALUE` implies idempotent

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static DescriptorProtos.MethodOptions.IdempotencyLevel` | `forNumber(int value)`
    `static Descriptors.EnumDescriptor` | `getDescriptor()`
    `Descriptors.EnumDescriptor` | `getDescriptorForType()` Return the enum type's descriptor, which contains information about each defined value, etc.
    `int` | `getNumber()` Return the value's numeric value as defined in the .proto file.
    `Descriptors.EnumValueDescriptor` | `getValueDescriptor()` Return the value's descriptor, which contains information such as value name, number, and type.
    `static Internal.EnumLiteMap<DescriptorProtos.MethodOptions.IdempotencyLevel>` | `internalGetValueMap()`
    `static DescriptorProtos.MethodOptions.IdempotencyLevel` | `valueOf(Descriptors.EnumValueDescriptor desc)`
    `static DescriptorProtos.MethodOptions.IdempotencyLevel` | `valueOf(int value)` Deprecated. Use `forNumber(int)` instead.
    `static DescriptorProtos.MethodOptions.IdempotencyLevel` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static DescriptorProtos.MethodOptions.IdempotencyLevel[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### IDEMPOTENCY_UNKNOWN

          public static final DescriptorProtos.MethodOptions.IdempotencyLevel IDEMPOTENCY_UNKNOWN

      `IDEMPOTENCY_UNKNOWN = 0;`

    - #### NO_SIDE_EFFECTS

          public static final DescriptorProtos.MethodOptions.IdempotencyLevel NO_SIDE_EFFECTS

           implies idempotent

      `NO_SIDE_EFFECTS = 1;`

    - #### IDEMPOTENT

          public static final DescriptorProtos.MethodOptions.IdempotencyLevel IDEMPOTENT

           idempotent, but may have side effects

      `IDEMPOTENT = 2;`

  - ### Field Detail

    - #### IDEMPOTENCY_UNKNOWN_VALUE

          public static final int IDEMPOTENCY_UNKNOWN_VALUE

      `IDEMPOTENCY_UNKNOWN = 0;`
      See Also:
        Constant Field Values

    - #### NO_SIDE_EFFECTS_VALUE

          public static final int NO_SIDE_EFFECTS_VALUE

           implies idempotent

      `NO_SIDE_EFFECTS = 1;`
      See Also:
        Constant Field Values

    - #### IDEMPOTENT_VALUE

          public static final int IDEMPOTENT_VALUE

           idempotent, but may have side effects

      `IDEMPOTENT = 2;`
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### values

          public static DescriptorProtos.MethodOptions.IdempotencyLevel[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (DescriptorProtos.MethodOptions.IdempotencyLevel c : DescriptorProtos.MethodOptions.IdempotencyLevel.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static DescriptorProtos.MethodOptions.IdempotencyLevel valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getNumber

          public final int getNumber()

      Description copied from interface: `ProtocolMessageEnum`
      Return the value's numeric value as defined in the .proto file.
      Specified by:
        `getNumber` in interface `Internal.EnumLite`
      Specified by:
        `getNumber` in interface `ProtocolMessageEnum`

    - #### valueOf

          @Deprecated
          public static DescriptorProtos.MethodOptions.IdempotencyLevel valueOf(int value)

      Deprecated. Use `forNumber(int)` instead.

    - #### forNumber

          public static DescriptorProtos.MethodOptions.IdempotencyLevel forNumber(int value)

    - #### internalGetValueMap

          public static Internal.EnumLiteMap<DescriptorProtos.MethodOptions.IdempotencyLevel> internalGetValueMap()

    - #### getValueDescriptor

          public final Descriptors.EnumValueDescriptor getValueDescriptor()

      Description copied from interface: `ProtocolMessageEnum`
      Return the value's descriptor, which contains information such as value name, number, and type.
      Specified by:
        `getValueDescriptor` in interface `ProtocolMessageEnum`

    - #### getDescriptorForType

          public final Descriptors.EnumDescriptor getDescriptorForType()

      Description copied from interface: `ProtocolMessageEnum`
      Return the enum type's descriptor, which contains information about each defined value, etc.
      Specified by:
        `getDescriptorForType` in interface `ProtocolMessageEnum`

    - #### getDescriptor

          public static final Descriptors.EnumDescriptor getDescriptor()

    - #### valueOf

          public static DescriptorProtos.MethodOptions.IdempotencyLevel valueOf(Descriptors.EnumValueDescriptor desc)